-- Ballenfuttermod by acert 2012
-- Find me at modhoster.de


RBallenfuttermod = {};

function RBallenfuttermod.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Trailer, specializations);
end;

function RBallenfuttermod:load(xmlFile)
  
	self.hayBale = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.ballen.hayBale#index"));
	setVisibility(self.hayBale, false);
	
	
	
	self.objectInRange = RBallenfuttermod.objectInRange;

	
    self.lastRBallenfuttermodArea = 0;
    self.RBallenfuttermodGroundFlag = self:getNextDirtyFlag();

	self.baleSearchNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.baleSearchNode#index"));

end;

function RBallenfuttermod:delete()
end;


function RBallenfuttermod:mouseEvent(posX, posY, isDown, isUp, button)
end;

function RBallenfuttermod:keyEvent(unicode, sym, modifier, isDown)
end;

function RBallenfuttermod:update(dt)

end;

function RBallenfuttermod:updateTick(dt)
  
    if self:getIsActive() then
			
					local bale = self:objectInRange(self.baleSearchNode);
					if bale ~= nil then
						baleId = networkGetObjectId(bale);
						bale = networkGetObject(baleId);
						if getUserAttribute(bale.nodeId, "isRoundbale") then
								if self.currentFillType == Fillable.FILLTYPE_UNKNOWN then
									self.fillLevel = 3000;
									self.currentFillType = Fillable.FILLTYPE_GRASS;
									setVisibility(self.hayBale, true);
								end;
						end;
						
						bale:delete();
					end;
				if self.fillLevel < 10 then
							setVisibility(self.hayBale, false);
						end;
						if self.fillLevel == 3000 then
							setScale(self.hayBale, 1, 1, 1);
						end;
						if self.fillLevel < 2500 then
							setScale(self.hayBale, 0.9, 0.9, 1);
						end;
						if self.fillLevel < 2300 then
							setScale(self.hayBale, 0.8, 0.8, 1);
						end;
						if self.fillLevel < 1900 then
							setScale(self.hayBale, 0.7, 0.7, 1);
						end;
						if self.fillLevel < 1600 then
							setScale(self.hayBale, 0.65, 0.65, 0.8);
						end;
						if self.fillLevel < 1100 then
							setScale(self.hayBale, 0.6, 0.6, 0.8);
						end;
						if self.fillLevel < 800 then
							setScale(self.hayBale, 0.57, 0.57, 0.7);
						end;
						if self.fillLevel < 600 then
							setScale(self.hayBale, 0.55, 0.55, 0.7);
						end;
						if self.fillLevel < 400 then
							setScale(self.hayBale, 0.54, 0.54, 0.7);
						end;
						if self.fillLevel < 200 then
							setScale(self.hayBale, 0.52, 0.52, 0.7);
						end;
						if self.fillLevel < 100 then
							setScale(self.hayBale, 0.5, 0.5, 0.7);
						end;			
				end; 
    end;
	
	


function RBallenfuttermod:draw()
end;


function RBallenfuttermod:objectInRange(refNode)
    local nearestDistance = 1;
    local nearestBale = nil;
    local px, py, pz = getWorldTranslation(refNode);
	for index, item in pairs(g_currentMission.itemsToSave) do
	    itemNode = item.item.nodeId;
	    if getParent(item.item.nodeId) == getRootNode() then
			if getUserAttribute(itemNode, "isRoundbale") then
				local vx, vy, vz = getWorldTranslation(itemNode);
				local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
				if distance < nearestDistance then
					index = index;
					nearestBale = item.item;
					nearestObject = itemNode;
					nearestDistance = distance;
				end;
			end;
		end;
	end;	
    return nearestBale;
end;